package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimPlacePositionLevel;
import com.izouma.awesomeadmin.service.AimPlacePositionLevelService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aimPlacePositionLevel")
public class AimPlacePositionLevelController {

    @Autowired
    private AimPlacePositionLevelService aimPlacePositionLevelService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimPlacePositionLevel record) {
        List<AimPlacePositionLevel> pp = aimPlacePositionLevelService.getAimPlacePositionLevelList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAimPlacePositionLevel", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimPlacePositionLevel(@RequestParam(required = false, value = "id") String id) {
        AimPlacePositionLevel data = aimPlacePositionLevelService.getAimPlacePositionLevelById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimPlacePositionLevel record) {
        AimPlacePositionLevel data = aimPlacePositionLevelService.getAimPlacePositionLevel(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimPlacePositionLevel record) {
        Map<String, Object> result = new HashMap<>();

        List<AimPlacePositionLevel> pp =aimPlacePositionLevelService.getAimPlacePositionLevelByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimPlacePositionLevel record) {
        boolean num = aimPlacePositionLevelService.createAimPlacePositionLevel(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimPlacePositionLevel(AimPlacePositionLevel record) {
        boolean num = aimPlacePositionLevelService.updateAimPlacePositionLevel(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimPlacePositionLevel(AimPlacePositionLevel record) {

        boolean num = aimPlacePositionLevelService.deleteAimPlacePositionLevel(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimPlacePositionLevel record) throws Exception {

    List<AimPlacePositionLevel> aimPlacePositionLevels = aimPlacePositionLevelService.getAimPlacePositionLevelList(record);


        String sheetName = "aim_place_position_level";
        String titleName = "目标点-位置层级表数据表";
        String fileName = "目标点-位置层级表表";
        int columnNumber = 14;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "所属地标ID" ,   "上一级" ,   "目标点-位置ID" ,   "是否顶级" ,   "备注1" ,   "备注2" ,   "备注3"  };
        String[][] dataList = new String[aimPlacePositionLevels.size()][14];

        for (int i = 0; i < aimPlacePositionLevels.size(); i++) {

                        dataList[i][0] = String.valueOf(aimPlacePositionLevels.get(i).getId());
                        dataList[i][1] = String.valueOf(aimPlacePositionLevels.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aimPlacePositionLevels.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aimPlacePositionLevels.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aimPlacePositionLevels.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aimPlacePositionLevels.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aimPlacePositionLevels.get(i).getName());
                        dataList[i][7] = String.valueOf(aimPlacePositionLevels.get(i).getOwnedLandMarkId());
                        dataList[i][8] = String.valueOf(aimPlacePositionLevels.get(i).getFrontLevelId());
                        dataList[i][9] = String.valueOf(aimPlacePositionLevels.get(i).getAimPlacePositionId());
                        dataList[i][10] = String.valueOf(aimPlacePositionLevels.get(i).getTopLevel());
                        dataList[i][11] = String.valueOf(aimPlacePositionLevels.get(i).getRemark1());
                        dataList[i][12] = String.valueOf(aimPlacePositionLevels.get(i).getRemark2());
                        dataList[i][13] = String.valueOf(aimPlacePositionLevels.get(i).getRemark3());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

